#include <cvirte.h>		
#include <userint.h>
#include <windows.h>
#include <tcpsupp.h>
#include <formatio.h>
#include <ansi_c.h>
#include "client.h"

static int panelHandle;
unsigned char akvizicija;
unsigned char uzorci[200];
unsigned char samplecount;

unsigned int suma;
unsigned int suma_kvadrata;
static char file_name[MAX_PATHNAME_LEN]; 
int file1;
static unsigned int veza; 
static int connected;
unsigned char prijem;
char stanje_komunikacije; 

int CVICALLBACK ClientTCPCB (unsigned handle, int event, int error,void *callbackData);


int main (int argc, char *argv[])
   {
   char tempBuf[256] = {0};
   char portNumStr[32];
   int  portNum;	
	
	
   if (InitCVIRTE (0, argv, 0) == 0)
      return -1;	/* out of memory */
   if ((panelHandle = LoadPanel (0, "client.uir", PANEL)) < 0)
      return -1;
	/* Unos imena servera */
   PromptPopup ("Ime servera?",
                 "Ukucaj ime racunara na kojem radi serverska "
                 "aplikacija.\n\n(na primer: abc.xyz.com ili xxx.xxx.xxx.xxx)",
                 tempBuf, 255);

    /* Unos broja porta na serveru */
   PromptPopup ("Broj porta?",
                 "Ukucaj broj porta koji koristi "
                 "serverska aplikacija.\n\n(na primer: 10000)",
                 portNumStr, 31);
   portNum = atoi (portNumStr); //string broja porta prebacuje se u broj
   /* Povezivanje sa TCP serverom... */
   if (ConnectToTCPServer (&veza, portNum, tempBuf, ClientTCPCB,NULL, 5000) < 0)
        MessagePopup("TCP Client", "Povezivanje sa serverom NIJE uspelo !");
   else
      {
      connected = 1;
      /* povezivanje uspesno, skupljanje informacija */
      SetCtrlVal (panelHandle, PANEL_LED_CONNECTED, 1);
      GetTCPHostAddr (tempBuf, 256);
	  SetCtrlVal(panelHandle,PANEL_CLIENT_IP,tempBuf);
	  
	  GetTCPHostName (tempBuf, 256);
	  SetCtrlVal(panelHandle,PANEL_CLIENT_NAME,tempBuf);
	  
	  GetTCPPeerAddr (veza, tempBuf, 256);
	  SetCtrlVal(panelHandle,PANEL_SERVER_IP,tempBuf);
      GetTCPPeerName (veza, tempBuf, 256);
	  SetCtrlVal(panelHandle,PANEL_SERVER_NAME,tempBuf);
      DisplayPanel (panelHandle);
      RunUserInterface ();
      }
    //prekid veze sa TCP serverom
   if (connected)
      DisconnectFromTCPServer (veza);
	
   DiscardPanel (panelHandle);
   return 0;
   }

int CVICALLBACK start_akvizicije (int panel, int control, int event,void *callbackData, int eventData1, int eventData2)
   {
   unsigned int samplerate;
   switch (event)
      {
	  case EVENT_COMMIT:
		 {
		 samplecount=0;
		 suma=0;
		 suma_kvadrata=0;
		 
		 GetCtrlVal (panelHandle, PANEL_SAMPLERATE, &samplerate);
		 SetCtrlAttribute (panelHandle, PANEL_TIMER, ATTR_INTERVAL, samplerate*0.01);
		 SetCtrlAttribute (panelHandle, PANEL_START, ATTR_DIMMED, 1);
		 SetCtrlAttribute (panelHandle, PANEL_SAMPLERATE, ATTR_DIMMED, 1);
		 SetCtrlAttribute (panelHandle, PANEL_KRAJ, ATTR_DIMMED, 0);
		 DeleteGraphPlot (panelHandle, PANEL_SIGNAL, -1, VAL_IMMEDIATE_DRAW);//-1 znaci obrisi sve grafike
		 FileSelectPopup ("", "*.acq", "*.acq","Ime datoteke", VAL_OK_BUTTON, 0, 1, 1,1, file_name);
		 file1 = OpenFile (file_name, VAL_READ_WRITE, VAL_OPEN_AS_IS, VAL_BINARY);
		 akvizicija=1;    
		 break;
      }  }
   return 0;
   }

int CVICALLBACK kraj_akvizicije (int panel, int control, int event,void *callbackData, int eventData1, int eventData2)
   {
   switch (event)
      {
	  case EVENT_COMMIT:
	     {
		 akvizicija=0;
		 SetCtrlAttribute (panelHandle, PANEL_START, ATTR_DIMMED, 0);
		 SetCtrlAttribute (panelHandle, PANEL_KRAJ, ATTR_DIMMED, 1);
		 SetCtrlAttribute (panelHandle, PANEL_SAMPLERATE, ATTR_DIMMED, 0);  
		 CloseFile (file1);
		 break;
      }  }
   return 0;
   }

int CVICALLBACK Izlaz (int panel, int control, int event,void *callbackData, int eventData1, int eventData2)
   {
   switch (event)
      {
	  case EVENT_COMMIT:
	     {
		 QuitUserInterface (0);
		 break;
	  }  }
   return 0;
   }

int CVICALLBACK timer (int panel, int control, int event,void *callbackData, int eventData1, int eventData2)
   {
   float srednja;
   float efektivna;
   char    transmitBuf[512] = {0}; 
   
   switch (event)
      {
	  case EVENT_TIMER_TICK:
	     {
		 switch (stanje_komunikacije)
		    {
			case 0://nista
			   {
			   if (akvizicija)                                                                                                                               
				  {                                                                                                                                          
				  if (samplecount<200) //manje od 200 uzoraka                                                                                                
				     {                                                                                                                                       
					 transmitBuf[0]='A';                                                                                                                     
					 transmitBuf[1]='\n';                                                                                                                    
					 if (ClientTCPWrite (veza, transmitBuf,2, 1000) < 0)                                                                                     
					    MessagePopup("","greska u slanju");                                                                                                  
					 stanje_komunikacije=1;
					 }                                                                                                                                       
				  else                                                                                                                                       
					 {                                                                                                                                       
					 akvizicija=0;                                                                                                                           
					 SetCtrlAttribute (panelHandle, PANEL_START, ATTR_DIMMED, 0);                                                                            
					 SetCtrlAttribute (panelHandle, PANEL_KRAJ, ATTR_DIMMED, 1);                                                                             
					 SetCtrlAttribute (panelHandle, PANEL_SAMPLERATE, ATTR_DIMMED, 0);                                                                       
					 CloseFile (file1);                                                                                                                      
				  }  }
			   break;
			   }
		    case 1://poslao sam poruku, cekam na odziv
			   {
			   //ostajem da cekam
			   break;
			   }
		    case 2://stigla poruka
			   {
			   stanje_komunikacije=0;
			   uzorci[samplecount]=prijem;                                                                                                            
			   SetCtrlVal(panelHandle, PANEL_TRENUTNA,prijem);                                                                                        
			   WriteFile (file1, &prijem, 1);                                                                                                         
			   suma+=prijem;                                                                                                                          
			   suma_kvadrata+=(prijem*prijem) ;                                                                                                       
			   if (samplecount)//linija se moze crtati samo ako imamo dva odbirka, nakon jednog odbirka se linija ne crta                             
			      PlotLine (panelHandle, PANEL_SIGNAL, samplecount-1, uzorci[samplecount-1], samplecount, uzorci[samplecount], VAL_RED);              
			   samplecount++;                                                                                                                         
			   srednja=(float)suma/(float)samplecount;SetCtrlVal(panelHandle, PANEL_SREDNJA,srednja);                                                 
			   efektivna=(float)suma_kvadrata/(float)samplecount;                                                                                     
			   efektivna=sqrt(efektivna);                                                                                                             
			   SetCtrlVal(panelHandle, PANEL_EFEKTIVNA,efektivna);                                                                                
			   break;
		    }  }
         break;
      }  }
   return 0;
   }



int CVICALLBACK ClientTCPCB (unsigned handle, int event, int error,void *callbackData)                                
   {                                                                               
   char receiveBuf[256] = {0};                                                 
   int  dataSize         = sizeof (receiveBuf) - 1;
   switch (event)                                                              
      {                                                                       
      case TCP_DATAREADY:                                                     
         {
		 if ((dataSize = ClientTCPRead (veza, receiveBuf,dataSize, 1000))< 0)                                                            
            {                                                               
            MessagePopup("","greska");
            }                                                               
         else                                                                
            {
			if (stanje_komunikacije==1) stanje_komunikacije=2;
			prijem= receiveBuf[0];
            }                                                               
         break;
	     }
      case TCP_DISCONNECT:
         {
		 MessagePopup ("TCP Client", "Server has closed connection!");       
         connected = 0;
		 SetCtrlVal (panelHandle, PANEL_LED_CONNECTED, 0);
         break;                                                              
      }  }                                                                         
   return 0;                                                                   
   }
